 
%% This script first runs a multilevel coarsening
%% of the graph (10 levels in this test) and then uses
%% the vertices of the last level graph to do the  expansion
%% 
%% 
close all;

[X,Y,tri,A] = create_graph;
K = size(A,1);

colors='rkbmrk';
dots = '^o*+xv';

h1=figure(1);
XY = [X'; Y'];
gplot(A,XY','g');
%%-------------------- call multilevel coarsening
hold on
pause 
[LEV, L] = mlcoarse(A, XY, 4);
%%-------------------- number of resulting domains
levs = length(LEV);
%%-------------------- centers
for l =1:levs
  Levl = LEV(l);
  A1 = Levl.mat;
  X1 = Levl.X;
  labl = Levl.mark;
  figure(l+1)
  gplot(A1, X1');
  pause
end
return


CTR = LEV(levs).X;
hold on
ND = length(CTR);
%%-------------------- this is to find the points 
%%                     of original graph that are closest
%%                     to the centers. 
for i=1:ND
    tt = XY - CTR(:,i) * ones(1,K);
    tt = sum(tt .* tt,1);
    [d, k] = min(tt)
    II(i) = k;
    plot(X(k), Y(k), 'ko','linewidth',4);
end
%%-------------------- do level set expansion now.. 

pause 

close(h1)

 figure(3)

display(' Do level expansion');
   [sets lab] = dse1(A,II, X, Y);
%%hold off

%%

%%gplot(A,[X,Y],'y');
%%hold on
%% for k=1:0
%%     thisset = sets(k).set;
%%     plot(X(thisset),Y(thisset),[dots(mod(k-1,6)+1) colors(mod(k-1,6)+1)]);
%% end
%%-------------------- interface lines ** 
%%interf_Lines(A, X, Y, L) ;
%% interf2(A, X, Y, lab);

